<?php
/******************************************************************************/
//                                                                            //
//                             InstantCMS v1.9                                //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2011                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/

    if($_SERVER['HTTP_X_REQUESTED_WITH'] != 'XMLHttpRequest') { die(); }
    header('Content-Type: text/html; charset=windows-1251'); 
    session_start();

    if (!isset($_REQUEST['module_id'])) { die(2); }
    if (!isset($_REQUEST['page'])) { die(4); }

    define("VALID_CMS", 1);
    define('PATH', $_SERVER['DOCUMENT_ROOT']);

    //    
    include(PATH.'/core/cms.php');
    //  
    include(PATH.'/includes/config.inc.php');
    $inCore = cmsCore::getInstance();

    define('HOST', 'http://' . $inCore->getHost());
    
    $inCore->loadClass('config'); 
    $inCore->loadClass('db'); 
    $inCore->loadClass('user');
    $inCore->loadClass('page');
    $inDB   = cmsDatabase::getInstance();

    //   
    $inCore->loadLanguage('lang');
    $inCore->loadLanguage('modules/mod_latestcol');

    //  
    $smarty = $inCore->initSmarty();

    //  
    $page        = $inCore->request('page', 'int', 1);    
    $module_id    = $inCore->request('module_id', 'int', '');

    //   
    $cfg = $inCore->loadModuleConfig($module_id);
    //   , 
    if (!$cfg['is_pag']) { die(); }

    $perpage    = $cfg['newscount'];

        if (!isset($cfg['showrss'])) { $cfg['showrss'] = 1; }
        if (!isset($cfg['subs'])) { $cfg['subs'] = 1; }
        if (!isset($cfg['newscount'])) { $cfg['newscount'] = 4; }
        if (!isset($cfg['cat_id'])) { $cfg['cat_id'] = 1; }
        if (!isset($cfg['cols'])) { $cfg['cols'] = 2; }
        if (!isset($cfg['img_width'])) { $cfg['img_width'] = 64; }
        if (!isset($cfg['show_img'])) { $cfg['show_img'] = 0; }
        if (!isset($cfg['max_char'])) { $cfg['max_char'] = 200; }
        if (!isset($cfg['replacer'])) { $cfg['replacer'] = " ... "; }
        if (!isset($cfg['strict'])) { $cfg['strict'] = 0; }
        if (!isset($cfg['middle'])) { $cfg['middle'] = 1; }
        if (!isset($cfg['img_name'])) { $cfg['img_name'] = 'kate.png'; }
        if (!isset($cfg['first_img'])) { $cfg['first_img'] = 1; }

    $today = date("Y-m-d H:i:s");
    
    if ($cfg['cat_id'] != '-1') {
            if (!$cfg['subs']){
                //select from category
                $catsql = ' AND con.category_id = '.$cfg['cat_id'];
            } else {
                //select from category and subcategories
                $rootcat = $inDB->get_fields('cms_category', "id='{$cfg['cat_id']}'", 'NSLeft, NSRight');
                if(!$rootcat) { exit; }
                $catsql = "AND (cat.NSLeft >= {$rootcat['NSLeft']} AND cat.NSRight <= {$rootcat['NSRight']})";
            }        
            $rssid = $cfg['cat_id'];

    } else { $catsql = ''; $rssid = 'all'; } 

    $sql = "SELECT con.*,
                       con.pubdate as fdate,
                       u.nickname as author,
                       u.login as author_login
                       FROM cms_content con
                       LEFT JOIN cms_category cat ON cat.id = con.category_id
                       LEFT JOIN cms_users u ON u.id = con.user_id
                       WHERE con.published = 1 AND con.showlatest = 1 AND con.is_arhive = 0 AND con.pubdate <= '$today'
                       AND (con.is_end=0 OR (con.is_end=1 AND con.enddate >= '$today'))
                       ".$catsql."
                       ORDER BY con.pubdate DESC
                       LIMIT ".(($page-1)*$perpage).", $perpage";

    $result = $inDB->query($sql);

    $is_con = false;

    //    
    $sql_total = "SELECT 1
            FROM cms_content con
            LEFT JOIN cms_category cat ON cat.id = con.category_id
            WHERE con.published = 1 AND con.showlatest = 1 AND con.is_arhive = 0 AND con.pubdate <= '$today' AND (con.is_end=0 OR (con.is_end=1 AND con.enddate >= '$today')) ".$catsql."";
    $result_total = $inDB->query($sql_total) ;
    $total_page = $inDB->num_rows($result_total);

    //         
    if ($total_page){

        $is_con = true;

        //    
        $inCore->loadModel('content');
        $model = new cms_model_content();

        $articles = array();                    
        while($con = $inDB->fetch_assoc($result)){
                $next = sizeof($articles);                
                $articles[$next]['id']          = $con['id'];
                $articles[$next]['title']       = $con['title'];
                $articles[$next]['hits']        = $con['hits'];
                $articles[$next]['href']        = $model->getArticleURL(null, $con['seolink']);
                $articles[$next]['author']      = $con['author'];
                $articles[$next]['authorhref']  = cmsUser::getProfileURL($con['author_login']);
                $articles[$next]['comments']    = $cfg['showcom'] ? $inCore->getCommentsCount('article', $con['id']) : false;
                $articles[$next]['date']        = $inCore->dateformat($con['fdate']);
                $articles[$next]['description'] = $con['description'];
                $inCore->processFilters( $articles[$next]['description']);

                if ($cfg['first_img']){
                        $in_desc = preg_match('/<img\s?[^>]*?\s?src="(.*?)"\s?[^>]*?\s?\/>/', $con['description'], $matches);
                        if (!$in_desc) { preg_match('/<img\s?[^>]*?\s?src="(.*?)"\s?[^>]*?\s?\/>/', $con['content'], $matches); }
                    if ($matches[1]){
                        if (file_exists(PATH.$matches[1])) {
                            $articles[$next]['first_image'] = $matches[1];
                        }
                    } else {
                        $articles[$next]['first_image'] = (file_exists(PATH.'/images/photos/small/article'.$con['id'].'.jpg') ? '/images/photos/small/article'.$con['id'].'.jpg' : '');
                    }
                } else {
                    $articles[$next]['image'] = (file_exists(PATH.'/images/photos/small/article'.$con['id'].'.jpg') ? 'article'.$con['id'].'.jpg' : '');
                }
        }
    }

    //   
    ob_start();
    $smarty = $inCore->initSmarty('modules', 'mod_latestcol.tpl');            
    $smarty->assign('articles', $articles);
    $smarty->assign('rssid', $rssid);
    $smarty->assign('cfg', $cfg);
    $smarty->assign('is_ajax', true);
    $smarty->assign('is_con', $is_con);
    $smarty->assign('module_id', $module_id);
    $smarty->assign('pagebar_module', cmsPage::getPagebar($total_page, $page, $perpage, 'javascript:conPageCol(%page%, '.$module_id.')'));
    $smarty->display('mod_latestcol.tpl');
    $html = ob_get_clean();
    echo $html;
?>
